/*
This file belongs to Ashes.
See LICENSE file in root folder.
*/
#if defined( CreateSemaphore )
#	undef CreateSemaphore
#endif

#if defined( CreateEvent )
#	define OldCreateEvent 1
#	undef CreateEvent
#endif

#define ASHES_MAKE_VERSION(major, minor, patch) \
    ((uint32_t(major) << 22) | (uint32_t(minor) << 12) | uint32_t(patch))

#ifndef VK_LIB_GLOBAL_FUNCTION
#	define VK_LIB_GLOBAL_FUNCTION( v, x )
#endif

#ifndef VK_LIB_GLOBAL_FUNCTION_EXT
#	define VK_LIB_GLOBAL_FUNCTION_EXT( v, n, x ) VK_LIB_GLOBAL_FUNCTION( v, x )
#endif

#ifndef VK_LIB_GLOBAL_FUNCTION_FALLBACK
#	define VK_LIB_GLOBAL_FUNCTION_FALLBACK( x )
#endif

#ifdef VK_VERSION_1_0
	VK_LIB_GLOBAL_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateInstance )
	VK_LIB_GLOBAL_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), EnumerateInstanceExtensionProperties )
	VK_LIB_GLOBAL_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), EnumerateInstanceLayerProperties )
#else
	VK_LIB_GLOBAL_FUNCTION_FALLBACK( CreateInstance )
	VK_LIB_GLOBAL_FUNCTION_FALLBACK( EnumerateInstanceExtensionProperties )
	VK_LIB_GLOBAL_FUNCTION_FALLBACK( EnumerateInstanceLayerProperties )
#endif

#ifdef VK_API_VERSION_1_1
	VK_LIB_GLOBAL_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), EnumerateInstanceVersion )
#else
	VK_LIB_GLOBAL_FUNCTION_FALLBACK( EnumerateInstanceVersion )
#endif

#undef VK_LIB_GLOBAL_FUNCTION
#undef VK_LIB_GLOBAL_FUNCTION_EXT
#undef VK_LIB_GLOBAL_FUNCTION_FALLBACK

#ifndef VK_LIB_INSTANCE_FUNCTION
#	define VK_LIB_INSTANCE_FUNCTION( v, x )
#endif

#ifndef VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT
#	define VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( v, n, x ) VK_LIB_INSTANCE_FUNCTION( v, x )
#endif

#ifndef VK_LIB_INSTANCE_FUNCTION_EXT
#	define VK_LIB_INSTANCE_FUNCTION_EXT( v, n, x ) VK_LIB_INSTANCE_FUNCTION( v, x )
#endif

#ifndef VK_LIB_INSTANCE_FUNCTION_FALLBACK
#	define VK_LIB_INSTANCE_FUNCTION_FALLBACK( x )
#endif

#ifdef VK_VERSION_1_0
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateDevice )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyInstance )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), EnumeratePhysicalDevices )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), EnumerateDeviceExtensionProperties )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), EnumerateDeviceLayerProperties )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetDeviceProcAddr )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceFeatures )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceFormatProperties )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceImageFormatProperties )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceMemoryProperties )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceProperties )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceQueueFamilyProperties )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceSparseImageFormatProperties )
#else
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( CreateDevice )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( DestroyInstance )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( EnumeratePhysicalDevices )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( EnumerateDeviceExtensionProperties )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( EnumerateDeviceLayerProperties )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetDeviceProcAddr )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceFeatures )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceFormatProperties )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceImageFormatProperties )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceMemoryProperties )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceProperties )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceQueueFamilyProperties )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceSparseImageFormatProperties )
#endif

#ifdef VK_API_VERSION_1_1
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), EnumeratePhysicalDeviceGroups )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetPhysicalDeviceFeatures2 )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetPhysicalDeviceProperties2 )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetPhysicalDeviceFormatProperties2 )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetPhysicalDeviceImageFormatProperties2 )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetPhysicalDeviceQueueFamilyProperties2 )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetPhysicalDeviceMemoryProperties2 )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetPhysicalDeviceSparseImageFormatProperties2 )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetPhysicalDeviceExternalBufferProperties )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetPhysicalDeviceExternalFenceProperties )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetPhysicalDeviceExternalSemaphoreProperties )
#else
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( EnumeratePhysicalDeviceGroups )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceFeatures2 )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceProperties2 )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceFormatProperties2 )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceImageFormatProperties2 )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceQueueFamilyProperties2 )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceMemoryProperties2 )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceSparseImageFormatProperties2 )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceExternalBufferProperties )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceExternalFenceProperties )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceExternalSemaphoreProperties )
#endif

#ifdef VK_KHR_surface
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SURFACE_EXTENSION_NAME, DestroySurfaceKHR )
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SURFACE_EXTENSION_NAME, GetPhysicalDeviceSurfaceCapabilitiesKHR )
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SURFACE_EXTENSION_NAME, GetPhysicalDeviceSurfaceFormatsKHR )
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SURFACE_EXTENSION_NAME, GetPhysicalDeviceSurfaceSupportKHR )
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SURFACE_EXTENSION_NAME, GetPhysicalDeviceSurfacePresentModesKHR )
#else
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( DestroySurfaceKHR )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceSurfaceCapabilitiesKHR )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceSurfaceFormatsKHR )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceSurfaceSupportKHR )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceSurfacePresentModesKHR )
#endif

#ifdef VK_API_VERSION_1_1
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 1, 0 ), VK_KHR_DEVICE_GROUP_EXTENSION_NAME, GetPhysicalDevicePresentRectanglesKHR )
#elif defined( VK_KHR_device_group )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DEVICE_GROUP_EXTENSION_NAME, GetPhysicalDevicePresentRectanglesKHR )
#else
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDevicePresentRectanglesKHR )
#endif

#ifdef VK_KHR_display
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DISPLAY_EXTENSION_NAME, GetPhysicalDeviceDisplayPropertiesKHR )
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DISPLAY_EXTENSION_NAME, GetPhysicalDeviceDisplayPlanePropertiesKHR )
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DISPLAY_EXTENSION_NAME, GetDisplayPlaneSupportedDisplaysKHR )
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DISPLAY_EXTENSION_NAME, GetDisplayModePropertiesKHR )
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DISPLAY_EXTENSION_NAME, CreateDisplayModeKHR )
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DISPLAY_EXTENSION_NAME, GetDisplayPlaneCapabilitiesKHR )
	VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DISPLAY_EXTENSION_NAME, CreateDisplayPlaneSurfaceKHR )
#else
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceDisplayPropertiesKHR )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetPhysicalDeviceDisplayPlanePropertiesKHR )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetDisplayPlaneSupportedDisplaysKHR )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetDisplayModePropertiesKHR )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( CreateDisplayModeKHR )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( GetDisplayPlaneCapabilitiesKHR )
	VK_LIB_INSTANCE_FUNCTION_FALLBACK( CreateDisplayPlaneSurfaceKHR )
#endif

#ifdef VK_KHR_get_display_properties2
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_DISPLAY_PROPERTIES_2_EXTENSION_NAME, GetPhysicalDeviceDisplayProperties2KHR )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_DISPLAY_PROPERTIES_2_EXTENSION_NAME, GetPhysicalDeviceDisplayPlaneProperties2KHR )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_DISPLAY_PROPERTIES_2_EXTENSION_NAME, GetDisplayModeProperties2KHR )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_DISPLAY_PROPERTIES_2_EXTENSION_NAME, GetDisplayPlaneCapabilities2KHR )
#endif

#ifdef VK_KHR_get_physical_device_properties2
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, GetPhysicalDeviceFeatures2KHR )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, GetPhysicalDeviceProperties2KHR )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, GetPhysicalDeviceFormatProperties2KHR )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, GetPhysicalDeviceImageFormatProperties2KHR )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, GetPhysicalDeviceQueueFamilyProperties2KHR )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, GetPhysicalDeviceMemoryProperties2KHR )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, GetPhysicalDeviceSparseImageFormatProperties2KHR )
#endif

#ifdef VK_KHR_device_group_creation
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DEVICE_GROUP_CREATION_EXTENSION_NAME, EnumeratePhysicalDeviceGroupsKHR )
#endif

#ifdef VK_KHR_external_memory_capabilities
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME, GetPhysicalDeviceExternalBufferPropertiesKHR )
#endif

#ifdef VK_KHR_external_semaphore_capabilities
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_EXTENSION_NAME, GetPhysicalDeviceExternalSemaphorePropertiesKHR )
#endif

#ifdef VK_KHR_external_fence_capabilities
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_EXTERNAL_FENCE_CAPABILITIES_EXTENSION_NAME, GetPhysicalDeviceExternalFencePropertiesKHR )
#endif

#ifdef VK_KHR_get_surface_capabilities2
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_SURFACE_CAPABILITIES_2_EXTENSION_NAME, GetPhysicalDeviceSurfaceCapabilities2KHR )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_SURFACE_CAPABILITIES_2_EXTENSION_NAME, GetPhysicalDeviceSurfaceFormats2KHR )
#endif

#ifdef VK_EXT_debug_report
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_REPORT_EXTENSION_NAME, CreateDebugReportCallbackEXT )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_REPORT_EXTENSION_NAME, DestroyDebugReportCallbackEXT )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_REPORT_EXTENSION_NAME, DebugReportMessageEXT )
#endif

#ifdef VK_NV_external_memory_capabilities
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME, GetPhysicalDeviceExternalImageFormatPropertiesNV )
#endif

#ifdef VK_EXT_direct_mode_display
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DIRECT_MODE_DISPLAY_EXTENSION_NAME, ReleaseDisplayEXT )
#endif

#ifdef VK_NVX_device_generated_commands
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NVX_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME, GetPhysicalDeviceGeneratedCommandsPropertiesNVX )
#endif

#ifdef VK_EXT_display_surface_counter
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DISPLAY_SURFACE_COUNTER_EXTENSION_NAME, GetPhysicalDeviceSurfaceCapabilities2EXT )
#endif

#ifdef VK_EXT_debug_utils
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, CreateDebugUtilsMessengerEXT )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, DestroyDebugUtilsMessengerEXT )
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, SubmitDebugUtilsMessageEXT )
#endif

#ifdef VK_EXT_sample_locations
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_SAMPLE_LOCATIONS_EXTENSION_NAME, GetPhysicalDeviceMultisamplePropertiesEXT )
#endif

#ifdef VK_EXT_calibrated_timestamps
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_CALIBRATED_TIMESTAMPS_EXTENSION_NAME, GetPhysicalDeviceCalibrateableTimeDomainsEXT )
#endif

#ifdef VK_NV_cooperative_matrix
	VK_LIB_INSTANCE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_COOPERATIVE_MATRIX_EXTENSION_NAME, GetPhysicalDeviceCooperativeMatrixPropertiesNV )
#endif

#ifdef VK_USE_PLATFORM_ANDROID_KHR
#	ifdef VK_KHR_android_surface
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateAndroidSurfaceKHR )
#	endif
#endif

#ifdef VK_USE_PLATFORM_MIR_KHR
#	ifdef VK_KHR_mir_surface
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateMirSurfaceKHR )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceMirPresentationSupportKHR )
#	endif
#endif

#ifdef __linux__
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateXcbSurfaceKHR )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceXcbPresentationSupportKHR )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateXlibSurfaceKHR )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceXlibPresentationSupportKHR )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateWaylandSurfaceKHR )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceWaylandPresentationSupportKHR )
#endif

#ifdef _WIN32
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateWin32SurfaceKHR )
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPhysicalDeviceWin32PresentationSupportKHR )
#endif

#ifdef __APPLE__
	VK_LIB_INSTANCE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateMacOSSurfaceMVK )
#endif

#undef VK_LIB_INSTANCE_FUNCTION_FALLBACK
#undef VK_LIB_INSTANCE_FUNCTION
#undef VK_LIB_INSTANCE_FUNCTION_EXT
#undef VK_LIB_INSTANCE_FUNCTION_MANDATORY_EXT

#ifndef VK_LIB_DEVICE_FUNCTION
#	define VK_LIB_DEVICE_FUNCTION( v, x )
#endif

#ifndef VK_LIB_DEVICE_FUNCTION_EXT
#	define VK_LIB_DEVICE_FUNCTION_EXT( v, n, x ) VK_LIB_DEVICE_FUNCTION( v, x )
#endif

#ifndef VK_LIB_DEVICE_FUNCTION_MANDATORY_EXT
#	define VK_LIB_DEVICE_FUNCTION_MANDATORY_EXT( v, n, x ) VK_LIB_DEVICE_FUNCTION( v, x )
#endif

#ifndef VK_STATIC_LIB_DEVICE_FUNCTION_EXT
#	define VK_STATIC_LIB_DEVICE_FUNCTION_EXT( v, n, x ) VK_LIB_DEVICE_FUNCTION_MANDATORY_EXT( v, n, x )
#endif

#ifndef VK_LIB_DEVICE_FUNCTION_FALLBACK
#	define VK_LIB_DEVICE_FUNCTION_FALLBACK( x )
#endif

#ifdef VK_VERSION_1_0
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), AllocateCommandBuffers )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), AllocateDescriptorSets )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), AllocateMemory )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), BeginCommandBuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), BindBufferMemory )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), BindImageMemory )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdBeginQuery )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdBeginRenderPass )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdBindDescriptorSets )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdBindIndexBuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdBindPipeline )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdBindVertexBuffers )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdBlitImage )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdClearAttachments )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdClearColorImage )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdClearDepthStencilImage )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdCopyBuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdCopyBufferToImage )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdCopyImage )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdDispatch )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdDispatchIndirect )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdDraw )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdDrawIndexed )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdDrawIndirect )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdDrawIndexedIndirect )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdEndQuery )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdEndRenderPass )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdExecuteCommands )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdCopyImageToBuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdNextSubpass )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdPipelineBarrier )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdPushConstants )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdResetEvent )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdResetQueryPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdSetDepthBias )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdSetEvent )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdSetLineWidth )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdSetScissor )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdSetViewport )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdWaitEvents )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdWriteTimestamp )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateBuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateBufferView )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateCommandPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateComputePipelines )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateDescriptorPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateDescriptorSetLayout )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateEvent )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateFence )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateFramebuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateGraphicsPipelines )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateImage )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateImageView )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreatePipelineLayout )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateRenderPass )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateQueryPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateSampler )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateSemaphore )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreateShaderModule )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyBuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyBufferView )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyCommandPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyDescriptorPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyDescriptorSetLayout )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyDevice )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyEvent )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyFence )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyFramebuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyImage )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyImageView )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyPipeline )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyPipelineLayout )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyQueryPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyRenderPass )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroySampler )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroySemaphore )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyShaderModule )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DeviceWaitIdle )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), EndCommandBuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), FlushMappedMemoryRanges )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), FreeCommandBuffers )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), FreeDescriptorSets )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), FreeMemory )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetBufferMemoryRequirements )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetDeviceQueue )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetEventStatus )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetImageMemoryRequirements )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetImageSparseMemoryRequirements )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetImageSubresourceLayout )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetQueryPoolResults )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), InvalidateMappedMemoryRanges )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetDeviceMemoryCommitment )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), MapMemory )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), QueueSubmit )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), QueueWaitIdle )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), ResetCommandBuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), ResetEvent )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), ResetFences )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), SetEvent )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), UnmapMemory )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), UpdateDescriptorSets )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), WaitForFences )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CreatePipelineCache )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), DestroyPipelineCache )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetPipelineCacheData )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), MergePipelineCaches )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), ResetDescriptorPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetRenderAreaGranularity )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdSetBlendConstants )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdSetDepthBounds )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdSetStencilCompareMask )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdSetStencilWriteMask )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdSetStencilReference )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdUpdateBuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdFillBuffer )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdResolveImage )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), QueueBindSparse )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), GetFenceStatus )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), ResetCommandPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 0, 0 ), CmdCopyQueryPoolResults )
#else
	VK_LIB_DEVICE_FUNCTION_FALLBACK( AllocateCommandBuffers )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( AllocateDescriptorSets )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( AllocateMemory )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( BeginCommandBuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( BindBufferMemory )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( BindImageMemory )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdBeginQuery )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdBeginRenderPass )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdBindDescriptorSets )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdBindIndexBuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdBindPipeline )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdBindVertexBuffers )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdBlitImage )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdClearAttachments )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdClearColorImage )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdClearDepthStencilImage )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdCopyBuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdCopyBufferToImage )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdCopyImage )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdDispatch )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdDispatchIndirect )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdDraw )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdDrawIndexed )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdDrawIndirect )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdDrawIndexedIndirect )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdEndQuery )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdEndRenderPass )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdExecuteCommands )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdCopyImageToBuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdNextSubpass )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdPipelineBarrier )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdPushConstants )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdResetEvent )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdResetQueryPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetDepthBias )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetEvent )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetLineWidth )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetScissor )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetViewport )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdWaitEvents )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdWriteTimestamp )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateBuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateBufferView )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateCommandPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateComputePipelines )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateDescriptorPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateDescriptorSetLayout )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateEvent )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateFence )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateFramebuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateGraphicsPipelines )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateImage )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateImageView )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreatePipelineLayout )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateRenderPass )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateQueryPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateSampler )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateSemaphore )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateShaderModule )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyBuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyBufferView )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyCommandPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyDescriptorPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyDescriptorSetLayout )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyDevice )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyEvent )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyFence )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyFramebuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyImage )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyImageView )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyPipeline )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyPipelineLayout )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyQueryPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyRenderPass )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroySampler )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroySemaphore )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyShaderModule )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DeviceWaitIdle )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( EndCommandBuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( FlushMappedMemoryRanges )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( FreeCommandBuffers )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( FreeDescriptorSets )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( FreeMemory )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetBufferMemoryRequirements )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetDeviceQueue )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetEventStatus )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetImageMemoryRequirements )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetImageSparseMemoryRequirements )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetImageSubresourceLayout )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetQueryPoolResults )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( InvalidateMappedMemoryRanges )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetDeviceMemoryCommitment )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( MapMemory )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( QueueSubmit )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( QueueWaitIdle )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( ResetCommandBuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( ResetEvent )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( ResetFences )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( SetEvent )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( UnmapMemory )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( UpdateDescriptorSets )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( WaitForFences )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreatePipelineCache )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyPipelineCache )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetPipelineCacheData )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( MergePipelineCaches )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( ResetDescriptorPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetRenderAreaGranularity )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetBlendConstants )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetDepthBounds )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetStencilCompareMask )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetStencilWriteMask )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetStencilReference )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdUpdateBuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdFillBuffer )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdResolveImage )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( QueueBindSparse )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetFenceStatus )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( ResetCommandPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdCopyQueryPoolResults )
#endif

#ifdef VK_API_VERSION_1_1
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), BindBufferMemory2 )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), BindImageMemory2 )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetDeviceGroupPeerMemoryFeatures )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), CmdSetDeviceMask )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), CmdDispatchBase )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetImageMemoryRequirements2 )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetBufferMemoryRequirements2 )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetImageSparseMemoryRequirements2 )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), TrimCommandPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetDeviceQueue2 )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), CreateSamplerYcbcrConversion )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), DestroySamplerYcbcrConversion )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), CreateDescriptorUpdateTemplate )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), DestroyDescriptorUpdateTemplate )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), UpdateDescriptorSetWithTemplate )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 1, 0 ), GetDescriptorSetLayoutSupport )
#else
	VK_LIB_DEVICE_FUNCTION_FALLBACK( BindBufferMemory2 )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( BindImageMemory2 )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetDeviceGroupPeerMemoryFeatures )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdSetDeviceMask )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdDispatchBase )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetImageMemoryRequirements2 )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetBufferMemoryRequirements2 )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetImageSparseMemoryRequirements2 )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( TrimCommandPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetDeviceQueue2 )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateSamplerYcbcrConversion )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroySamplerYcbcrConversion )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateDescriptorUpdateTemplate )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroyDescriptorUpdateTemplate )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( UpdateDescriptorSetWithTemplate )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetDescriptorSetLayoutSupport )
#endif

#ifdef VK_API_VERSION_1_2
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), CmdDrawIndirectCount )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), CmdDrawIndexedIndirectCount )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), CreateRenderPass2 )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), CmdBeginRenderPass2 )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), CmdNextSubpass2 )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), CmdEndRenderPass2 )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), ResetQueryPool )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), GetSemaphoreCounterValue )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), WaitSemaphores )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), SignalSemaphore )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), GetBufferDeviceAddress )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), GetBufferOpaqueCaptureAddress )
	VK_LIB_DEVICE_FUNCTION( ASHES_MAKE_VERSION( 1, 2, 0 ), GetDeviceMemoryOpaqueCaptureAddress )
#else
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdDrawIndirectCount )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdDrawIndexedIndirectCount )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateRenderPass2 )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdBeginRenderPass2 )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdNextSubpass2 )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CmdEndRenderPass2 )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( ResetQueryPool )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetSemaphoreCounterValue )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( WaitSemaphores )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( SignalSemaphore )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetBufferDeviceAddress )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetBufferOpaqueCaptureAddress )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetDeviceMemoryOpaqueCaptureAddress )
#endif

#ifdef VK_KHR_swapchain
	VK_STATIC_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, CreateSwapchainKHR )
	VK_STATIC_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, DestroySwapchainKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, GetSwapchainImagesKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, AcquireNextImageKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, QueuePresentKHR )
#	ifdef VK_API_VERSION_1_1
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 1, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, GetDeviceGroupPresentCapabilitiesKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 1, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, GetDeviceGroupSurfacePresentModesKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 1, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, AcquireNextImage2KHR )
#	endif
#else
	VK_LIB_DEVICE_FUNCTION_FALLBACK( CreateSwapchainKHR )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( DestroySwapchainKHR )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetSwapchainImagesKHR )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( AcquireNextImageKHR )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( QueuePresentKHR )
#endif

#ifdef VK_KHR_device_group
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, GetDeviceGroupPeerMemoryFeaturesKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, CmdSetDeviceMaskKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SWAPCHAIN_EXTENSION_NAME, CmdDispatchBaseKHR )
#	ifndef VK_API_VERSION_1_1
	VK_LIB_DEVICE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DEVICE_GROUP_EXTENSION_NAME, GetDeviceGroupPresentCapabilitiesKHR )
	VK_LIB_DEVICE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DEVICE_GROUP_EXTENSION_NAME, GetDeviceGroupSurfacePresentModesKHR )
	VK_LIB_DEVICE_FUNCTION_MANDATORY_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DEVICE_GROUP_EXTENSION_NAME, AcquireNextImage2KHR )
#	endif
#endif
#ifndef VK_KHR_device_group
#	ifndef VK_API_VERSION_1_1
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetDeviceGroupPresentCapabilitiesKHR )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( GetDeviceGroupSurfacePresentModesKHR )
	VK_LIB_DEVICE_FUNCTION_FALLBACK( AcquireNextImage2KHR )
#	endif
#endif

#ifdef VK_KHR_maintenance1
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_MAINTENANCE1_EXTENSION_NAME, TrimCommandPoolKHR )
#endif

#ifdef VK_KHR_external_memory_fd
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_EXTERNAL_MEMORY_FD_EXTENSION_NAME, GetMemoryFdKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_EXTERNAL_MEMORY_FD_EXTENSION_NAME, GetMemoryFdPropertiesKHR )
#endif

#ifdef VK_KHR_external_semaphore_fd
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_EXTERNAL_SEMAPHORE_FD_EXTENSION_NAME, ImportSemaphoreFdKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_EXTERNAL_SEMAPHORE_FD_EXTENSION_NAME, GetSemaphoreFdKHR )
#endif

#ifdef VK_KHR_push_descriptor
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_PUSH_DESCRIPTOR_EXTENSION_NAME, CmdPushDescriptorSetKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_PUSH_DESCRIPTOR_EXTENSION_NAME, CmdPushDescriptorSetWithTemplateKHR )
#endif

#ifdef VK_KHR_descriptor_update_template
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DESCRIPTOR_UPDATE_TEMPLATE_EXTENSION_NAME, CreateDescriptorUpdateTemplateKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DESCRIPTOR_UPDATE_TEMPLATE_EXTENSION_NAME, DestroyDescriptorUpdateTemplateKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DESCRIPTOR_UPDATE_TEMPLATE_EXTENSION_NAME, UpdateDescriptorSetWithTemplateKHR )
#endif

#ifdef VK_KHR_create_renderpass2
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_CREATE_RENDERPASS_2_EXTENSION_NAME, CreateRenderPass2KHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_CREATE_RENDERPASS_2_EXTENSION_NAME, CmdBeginRenderPass2KHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_CREATE_RENDERPASS_2_EXTENSION_NAME, CmdNextSubpass2KHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_CREATE_RENDERPASS_2_EXTENSION_NAME, CmdEndRenderPass2KHR )
#endif

#ifdef VK_KHR_shared_presentable_image
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SHARED_PRESENTABLE_IMAGE_EXTENSION_NAME, GetSwapchainStatusKHR )
#endif

#ifdef VK_KHR_external_fence_fd
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_EXTERNAL_FENCE_FD_EXTENSION_NAME, ImportFenceFdKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_EXTERNAL_FENCE_FD_EXTENSION_NAME, GetFenceFdKHR )
#endif

#ifdef VK_KHR_get_memory_requirements2
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME, GetImageMemoryRequirements2KHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME, GetBufferMemoryRequirements2KHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME, GetImageSparseMemoryRequirements2KHR )
#endif

#ifdef VK_KHR_sampler_ycbcr_conversion
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SAMPLER_YCBCR_CONVERSION_EXTENSION_NAME, CreateSamplerYcbcrConversionKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_SAMPLER_YCBCR_CONVERSION_EXTENSION_NAME, DestroySamplerYcbcrConversionKHR )
#endif

#ifdef VK_KHR_bind_memory2
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_BIND_MEMORY_2_EXTENSION_NAME, BindBufferMemory2KHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_BIND_MEMORY_2_EXTENSION_NAME, BindImageMemory2KHR )
#endif

#ifdef VK_KHR_maintenance3
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_MAINTENANCE3_EXTENSION_NAME, GetDescriptorSetLayoutSupportKHR )
#endif

#ifdef VK_KHR_draw_indirect_count
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DRAW_INDIRECT_COUNT_EXTENSION_NAME, CmdDrawIndirectCountKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_DRAW_INDIRECT_COUNT_EXTENSION_NAME, CmdDrawIndexedIndirectCountKHR )
#endif

#ifdef VK_EXT_debug_marker
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_MARKER_EXTENSION_NAME, DebugMarkerSetObjectTagEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_MARKER_EXTENSION_NAME, DebugMarkerSetObjectNameEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_MARKER_EXTENSION_NAME, CmdDebugMarkerBeginEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_MARKER_EXTENSION_NAME, CmdDebugMarkerEndEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_MARKER_EXTENSION_NAME, CmdDebugMarkerInsertEXT )
#endif

#ifdef VK_EXT_transform_feedback
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_TRANSFORM_FEEDBACK_EXTENSION_NAME, CmdBindTransformFeedbackBuffersEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_TRANSFORM_FEEDBACK_EXTENSION_NAME, CmdBeginTransformFeedbackEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_TRANSFORM_FEEDBACK_EXTENSION_NAME, CmdEndTransformFeedbackEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_TRANSFORM_FEEDBACK_EXTENSION_NAME, CmdBeginQueryIndexedEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_TRANSFORM_FEEDBACK_EXTENSION_NAME, CmdEndQueryIndexedEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_TRANSFORM_FEEDBACK_EXTENSION_NAME, CmdDrawIndirectByteCountEXT )
#endif

#ifdef VK_AMD_draw_indirect_count
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_AMD_DRAW_INDIRECT_COUNT_EXTENSION_NAME, CmdDrawIndirectCountAMD )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_AMD_DRAW_INDIRECT_COUNT_EXTENSION_NAME, CmdDrawIndexedIndirectCountAMD )
#endif

#ifdef VK_AMD_shader_info
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_AMD_SHADER_INFO_EXTENSION_NAME, GetShaderInfoAMD )
#endif

#ifdef VK_EXT_conditional_rendering
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_CONDITIONAL_RENDERING_EXTENSION_NAME, CmdBeginConditionalRenderingEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_CONDITIONAL_RENDERING_EXTENSION_NAME, CmdEndConditionalRenderingEXT )
#endif

#ifdef VK_NVX_device_generated_commands
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NVX_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME, CmdProcessCommandsNVX )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NVX_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME, CmdReserveSpaceForCommandsNVX )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NVX_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME, CreateIndirectCommandsLayoutNVX )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NVX_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME, DestroyIndirectCommandsLayoutNVX )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NVX_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME, CreateObjectTableNVX )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NVX_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME, DestroyObjectTableNVX )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NVX_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME, RegisterObjectsNVX )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NVX_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME, UnregisterObjectsNVX )
#endif

#ifdef VK_NV_clip_space_w_scaling
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_CLIP_SPACE_W_SCALING_EXTENSION_NAME, CmdSetViewportWScalingNV )
#endif

#ifdef VK_EXT_display_control
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DISPLAY_CONTROL_EXTENSION_NAME, DisplayPowerControlEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DISPLAY_CONTROL_EXTENSION_NAME, RegisterDeviceEventEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DISPLAY_CONTROL_EXTENSION_NAME, RegisterDisplayEventEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DISPLAY_CONTROL_EXTENSION_NAME, GetSwapchainCounterEXT )
#endif

#ifdef VK_GOOGLE_display_timing
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_GOOGLE_DISPLAY_TIMING_EXTENSION_NAME, GetRefreshCycleDurationGOOGLE )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_GOOGLE_DISPLAY_TIMING_EXTENSION_NAME, GetPastPresentationTimingGOOGLE )
#endif

#ifdef VK_EXT_discard_rectangles
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DISCARD_RECTANGLES_EXTENSION_NAME, CmdSetDiscardRectangleEXT )
#endif

#ifdef VK_EXT_hdr_metadata
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_HDR_METADATA_EXTENSION_NAME, SetHdrMetadataEXT )
#endif

#ifdef VK_EXT_debug_utils
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, SetDebugUtilsObjectNameEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, SetDebugUtilsObjectTagEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, QueueBeginDebugUtilsLabelEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, QueueEndDebugUtilsLabelEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, QueueInsertDebugUtilsLabelEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, CmdBeginDebugUtilsLabelEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, CmdEndDebugUtilsLabelEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_DEBUG_UTILS_EXTENSION_NAME, CmdInsertDebugUtilsLabelEXT )
#endif

#ifdef VK_EXT_sample_locations
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_SAMPLE_LOCATIONS_EXTENSION_NAME, CmdSetSampleLocationsEXT )
#endif

#ifdef VK_EXT_image_drm_format_modifier
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_IMAGE_DRM_FORMAT_MODIFIER_EXTENSION_NAME, GetImageDrmFormatModifierPropertiesEXT )
#endif

#ifdef VK_EXT_validation_cache
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_VALIDATION_CACHE_EXTENSION_NAME, CreateValidationCacheEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_VALIDATION_CACHE_EXTENSION_NAME, DestroyValidationCacheEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_VALIDATION_CACHE_EXTENSION_NAME, MergeValidationCachesEXT )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_VALIDATION_CACHE_EXTENSION_NAME, GetValidationCacheDataEXT )
#endif

#ifdef VK_NV_shading_rate_image
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_SHADING_RATE_IMAGE_EXTENSION_NAME, CmdBindShadingRateImageNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_SHADING_RATE_IMAGE_EXTENSION_NAME, CmdSetViewportShadingRatePaletteNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_SHADING_RATE_IMAGE_EXTENSION_NAME, CmdSetCoarseSampleOrderNV )
#endif

#ifdef VK_NV_ray_tracing
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, CreateAccelerationStructureNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, DestroyAccelerationStructureNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, GetAccelerationStructureMemoryRequirementsNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, BindAccelerationStructureMemoryNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, CmdBuildAccelerationStructureNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, CmdCopyAccelerationStructureNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, CmdTraceRaysNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, CreateRayTracingPipelinesNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, GetRayTracingShaderGroupHandlesNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, GetAccelerationStructureHandleNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, CmdWriteAccelerationStructuresPropertiesNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_RAY_TRACING_EXTENSION_NAME, CompileDeferredNV )
#endif

#ifdef VK_EXT_external_memory_host
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_EXTERNAL_MEMORY_HOST_EXTENSION_NAME, GetMemoryHostPointerPropertiesEXT )
#endif

#ifdef VK_AMD_buffer_marker
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_AMD_BUFFER_MARKER_EXTENSION_NAME, CmdWriteBufferMarkerAMD )
#endif

#ifdef VK_EXT_calibrated_timestamps
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_CALIBRATED_TIMESTAMPS_EXTENSION_NAME, GetCalibratedTimestampsEXT )
#endif

#ifdef VK_NV_mesh_shader
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_MESH_SHADER_EXTENSION_NAME, CmdDrawMeshTasksNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_MESH_SHADER_EXTENSION_NAME, CmdDrawMeshTasksIndirectNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_MESH_SHADER_EXTENSION_NAME, CmdDrawMeshTasksIndirectCountNV )
#endif

#ifdef VK_NV_scissor_exclusive
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_SCISSOR_EXCLUSIVE_EXTENSION_NAME, CmdSetExclusiveScissorNV )
#endif

#ifdef VK_NV_device_diagnostic_checkpoints
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_DEVICE_DIAGNOSTIC_CHECKPOINTS_EXTENSION_NAME, CmdSetCheckpointNV )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_NV_DEVICE_DIAGNOSTIC_CHECKPOINTS_EXTENSION_NAME, GetQueueCheckpointDataNV )
#endif

#ifdef VK_EXT_buffer_device_address
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_EXT_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME, GetBufferDeviceAddressEXT )
#endif

#ifdef VK_KHR_timeline_semaphore
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_TIMELINE_SEMAPHORE_EXTENSION_NAME, GetSemaphoreCounterValueKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_TIMELINE_SEMAPHORE_EXTENSION_NAME, WaitSemaphoresKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_TIMELINE_SEMAPHORE_EXTENSION_NAME, SignalSemaphoreKHR )
#endif

#ifdef VK_KHR_buffer_device_address
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME, GetBufferDeviceAddressKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME, GetBufferOpaqueCaptureAddressKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 0, 0 ), VK_KHR_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME, GetDeviceMemoryOpaqueCaptureAddressKHR )
#endif

#ifdef VK_KHR_deferred_host_operations
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME, CreateDeferredOperationKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME, DestroyDeferredOperationKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME, GetDeferredOperationMaxConcurrencyKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME, GetDeferredOperationResultKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME, DeferredOperationJoinKHR )
#endif

#ifdef VK_KHR_ray_tracing_pipeline
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_RAY_TRACING_PIPELINE_EXTENSION_NAME, CmdSetRayTracingPipelineStackSizeKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_RAY_TRACING_PIPELINE_EXTENSION_NAME, CmdTraceRaysIndirectKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_RAY_TRACING_PIPELINE_EXTENSION_NAME, CmdTraceRaysKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_RAY_TRACING_PIPELINE_EXTENSION_NAME, CreateRayTracingPipelinesKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_RAY_TRACING_PIPELINE_EXTENSION_NAME, GetRayTracingCaptureReplayShaderGroupHandlesKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_RAY_TRACING_PIPELINE_EXTENSION_NAME, GetRayTracingShaderGroupStackSizeKHR )
#endif

#ifdef VK_KHR_acceleration_structure
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, CreateAccelerationStructureKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, DestroyAccelerationStructureKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, CmdBuildAccelerationStructuresKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, CmdBuildAccelerationStructuresIndirectKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, BuildAccelerationStructuresKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, CopyAccelerationStructureKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, CopyAccelerationStructureToMemoryKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, CopyMemoryToAccelerationStructureKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, WriteAccelerationStructuresPropertiesKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, CmdCopyAccelerationStructureKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, CmdCopyAccelerationStructureToMemoryKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, CmdCopyMemoryToAccelerationStructureKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, GetAccelerationStructureDeviceAddressKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, CmdWriteAccelerationStructuresPropertiesKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, GetDeviceAccelerationStructureCompatibilityKHR )
	VK_LIB_DEVICE_FUNCTION_EXT( ASHES_MAKE_VERSION( 1, 2, 0 ), VK_KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME, GetAccelerationStructureBuildSizesKHR )
#endif

#undef VK_LIB_DEVICE_FUNCTION_FALLBACK
#undef VK_LIB_DEVICE_FUNCTION_MANDATORY_EXT
#undef VK_STATIC_LIB_DEVICE_FUNCTION_EXT
#undef VK_LIB_DEVICE_FUNCTION_EXT
#undef VK_LIB_DEVICE_FUNCTION
#undef ASHES_MAKE_VERSION

#if defined( OldCreateEvent )
#	if defined( _UNICODE )
#		define CreateEvent CreateEventW
#		define ResetEvent ResetEventW
#	else
#		define CreateEvent CreateEventA
#	endif
#endif
